pro js_groupspec,infile,outfile=outfile,resfile=resfile,mincount=mincount,_log=_log,silent=silent


  if (n_elements(mincount) eq 0) then mincount=1
  if (n_elements(outfile)  eq 0) then outfile='out.grp'
  if (n_elements(resfile)  eq 0) then resfile='nicer_channels_to_group.dat'

;  MUST have a grouping column in place already to start

  readcol,resfile,f='(i,i,i)',clow,chi,ngrp,silent=silent
  spec0=mrdfits(infile,0,head0,silent=silent)
  spec1=mrdfits(infile,1,head1,silent=silent)
  out = spec1

  pcnt=0L ; counts the photons in the current group
  gcnt=0L ; counts the number of channels in the current group
  GRP =1L ; group indexer

  group_vec = intarr(n_elements(spec1))-1
  cnt_vec   = lonarr(n_elements(spec1))-1
  nchan_vec = intarr(n_elements(spec1))-1

  
  for i=0L,n_elements(spec1)-1 do begin
     ind=i+1
     OUT[i].GROUPING=-666  ; to check that each channel is attended to.
          
     ; FIRST CHECKING ON THE PRIMARY BIN CONDITION
     loc = where(ind ge clow and ind le chi)

     if (n_elements(loc) gt 1) then begin
        print, 'BADNESS - 2 places at once'
        goto,crashout
     endif else begin
        if loc[0] gt -1 then begin           ; -- WITHIN THE BINNING BITS
                                ;  THERE IS A BIN CONDITION ON THIS CHANNEL ... CHECK IT
           if (GCNT eq 0L) then begin
                                ; PREVIOUS BIN WAS JUST CLOSED
              out[i].GROUPING = 1
              GCNT=1L
              PCNT=out[i].COUNTS ; the photon counter is now initialized
           endif else begin
              PCNT+=OUT[i].COUNTS
              IF (GCNT ge (ngrp[loc[0]]-1)) then begin
                                ; THIS BIN IS NOW FULL... check close condition
                 IF (PCNT ge MINCOUNT) then begin
                                ; close it
                    OUT[i].GROUPING=-1

                    pmax = pcnt
                    gmax = gcnt
                    gind = grp
                    
                    PCNT=0L
                    GCNT=0L
                    GRP++
                 endif else begin
                                ; keep it open
                    OUT[i].GROUPING=-1
                    GCNT++
                 endelse
              endif else begin
                                ; keep it open
                 OUT[i].GROUPING=-1
                 GCNT++
              endelse
           endelse

        endif else begin           ; NOT WITHIN THE BINNING COMMANDS
           pcnt+= OUT[i].COUNTS
           If (GCNT eq 0) then begin
              OUT[i].GROUPING=1
              GCNT=1
           endif else begin
              IF (PCNT ge MINCOUNT) then begin
                                ; close it
                 OUT[i].GROUPING=-1

                 pmax = pcnt
                 gmax = gcnt
                 gind = grp

                 PCNT=0L
                 GCNT=0L
                 GRP++
              endif else begin
                                ; keep it open
                 OUT[i].GROUPING=-1
                 GCNT++
              endelse
           endelse
        endelse
     endelse
;  endelse
     


     if (GCNT eq 0L) then begin
                                ; the last channel was closed... update the arrays:
        group_vec[i] = gind
        cnt_vec[gind]= pmax 
        nchan_vec[gind] = gmax
     endif else begin
                                ; still on group ... updating arrays
        if (GCNT GT 0L) then begin
           group_vec[i] = grp
           cnt_vec[grp]   = pcnt
           nchan_vec[grp] = gcnt
        endif
     endelse

     
  endfor
  
     mwrfits,spec0,outfile,head0,/create
     sxaddpar,head1,'RES-BINNING','1'
     mwrfits,out,outfile,head1
          
     crashout:
     _log={groups:group_vec, cnts: cnt_vec(where(cnt_vec ge 0)), nchan: nchan_vec(where(nchan_vec ge 0)), signal:spec1}
  end
  
